剑指Offer--6. 数组中出现次数超过一半的数字

题目描述

数组中有一个数字出现的次数超过数组长度的一半,请找出这个数字。
你可以假设数组是非空的,并且给定的数组总是存在多数元素。
示例 1
输入: [1, 2, 3, 2, 2, 2, 5, 4, 2]
输出: 2
限制:1 <= 数组长度 <= 50000

方法一: 使用HashMap

分析
遍历数组, 用hashMap将数组里面的值作为键, 出现的次数作为值存入。然后遍历Map,将值大于数组的长度的一半的键返回即可。

代码

class Solution {
    public int majorityElement(int[] nums) {
                Map<Integer,Integer> map = new HashMap<Integer,Integer>();
        
        int len = nums.length;
       for(int i = 0; i<len; i++){
           if(!map.containsKey(nums[i])){
               map.put(nums[i],1);
           }else{
                 map.put(nums[i], map.get(nums[i])+1);
           }
       }

       for(int b: map.keySet()) {
    	   if(map.get(b)>len/2) {
    		   return b;
    	   }
       }
       return 0;
    }
}

方法二: 使用投票法

分析:
详细请看LeetCode上的题解

代码:

class Solution {
    public int majorityElement(int[] nums) {
        int x = nums[0];
        int vote=0;
        for(int i=0; i<nums.length; i++){
            if(x==nums[i]){
                vote+=1;
            }else{
                vote-=1;
            }

            if(vote==0){
                x = nums[i];
            }
        }
        return x ;

    }          
}

方法三: 数组排序再找值

分析
此方法有些取巧, 数组排序; 由于取得元素的个数大于数组长度的一半,因此数组中间的数,必然是个数最多的那个数。

代码

class Solution {
    public int majorityElement(int[] nums) {
        int l = nums.length;
        Arrays.sort(nums);
        return nums[l/2];
    }          
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值